# == Class: mysqlmaster
#
# Full description of class mysqlmaster here.
# 
# This class install Mysql and setup it as a Master of MySQL Replicator. For now, it's only works with Ikoula Cloudstack Debian template and called by the following script PHP API using CloudStack Userdata :
#
# https://github.com/ikoula/cloudstack/blob/master/mysql-master.php
#
# === Authors
#
# Laurent H. Ikoula  <contrib@ikoula.com>
#
# === Copyright
#
# Copyright 2011 Your name here, unless otherwise noted.
#
class mysql::install {
    package { "mysql-server":
        ensure => present,
        }
    file { "/etc/mysql/my.cnf" :
        replace  => "true",
        source => "/etc/puppet/modules/mysqlmaster/files/etc.mysql.my.cnf",
        owner   => root,
        group   => root,
        require => Package['mysql-server'],
        mode    => 0644
    }
}
class mysql::passwd {
        exec { 'mysqlpasswd':
                command => 'mysqladmin -u root password `awk \'{print $1}\' /tmp/mysql`',
                path => '/usr/bin',
                require => Class["mysql::install"],
                logoutput => on_failure
        }
}
class mysql::master {
        exec { 'mysqlmaster':
                command => 'mysql -u root -p`awk \'{print $1}\' /tmp/mysql` -e "GRANT REPLICATION SLAVE ON *.* TO replic_user@\'%\' IDENTIFIED BY \'`awk \'{print $2}\' /tmp/mysql`\';" ; rm -f /tmp/mysql',
                path => '/usr/bin',
                require => [Class["mysql::install"],
                                Class["mysql::passwd"],
                                ]
        }
}
class mysql::service {
         case $::operatingsystem {
                'CentOS': {
                $mysql_service = 'mysqld'
                }
                'Fedora': {
                $mysql_service = 'mysqld'
                }
                'OpenSuSE': {
                $mysql_service = 'mysql'
                }
                'Debian': {
                $mysql_service = 'mysql'
                }
                'Ubuntu': {
                $mysql_service = 'mysql'
                }
                default: {
                $mysql_service  = 'mysql'
                }
        }
        #On s'assure que le service mysql est en cours d'exécution/activé :
        service { "$mysql_service" :
                        ensure     => running,
                        enable     => true,
                        hasrestart => true,
                        hasstatus => true,
                        require    => Class["mysql::install"],
        }
         exec { 'mysqlrestart':
                command => '/etc/init.d/mysql restart',
        }
}
class mysqlmaster {
        include mysql::install, mysql::passwd, mysql::master, mysql::service
}



